SystemOrganization addCategory: #'Philemon-Commons'!

!Dictionary methodsFor: '*philemon-commons' stamp: 'emm 9/23/2012 00:05'!
at: key ifAbsentPutUsing: aBlockClosure 
	
	^self at: key ifAbsent:[self at: key put: aBlockClosure value]! !

!SortedCollection methodsFor: '*Philemon-Commons' stamp: 'emm 05/08/2002 20:20'!
between: low and: high middlesDo: aBlock 
	
	| mid |
	low = ( high - 1 )
		ifFalse:
			[ mid := low + high // 2.
			 aBlock value: ( self at: mid ).
			self 
				between: low 
				and: mid 
				middlesDo: aBlock.
			self 
				between: mid 
				and: high 
				middlesDo: aBlock ]! !

!SortedCollection methodsFor: '*Philemon-Commons' stamp: 'emm 05/08/2002 20:20'!
binaryOrder

	| o |
	o := OrderedCollection new.
	self binaryOrderDo:[ :i |
		o add: i ].
	^o! !

!SortedCollection methodsFor: '*Philemon-Commons' stamp: 'emm 05/08/2002 20:20'!
binaryOrderDo: aBlock
	
	"(1 to: 9) asSortedCollection binaryOrderDo: #echo
	"

	self between: 1 and: self size middlesDo: aBlock.
	aBlock value: (self at: 1).
	aBlock value: (self at: self size).! !

OrderedCollection subclass: #CompositeCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!CompositeCollection class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example0
	"self example0"

	| cc |
	cc := self new.
	cc add: (1 to: 4).
	cc add: (3 to: -1 by: -1).
	^cc! !

!CompositeCollection methodsFor: 'overriding' stamp: 'emm 05/09/1999 23:14'!
at: index

	| collectionIndex |
	collectionIndex := index.
	super do:[ :each |
		collectionIndex > each size
			ifTrue: [ collectionIndex := collectionIndex - each size ]
			ifFalse: [ ^each at: collectionIndex ]].
	self error: 'index out of range'
		! !

!CompositeCollection methodsFor: 'overriding' stamp: 'emm 05/09/1999 23:14'!
collect: aBlock

	^(1 to: self size) collect:[ :index | self at: index ]! !

!CompositeCollection methodsFor: 'overriding' stamp: 'emm 05/09/1999 23:14'!
first

	^self at: 1! !

!CompositeCollection methodsFor: 'collections-accessing' stamp: 'emm 05/09/1999 23:14'!
includesCollection: aCollection

	super do:[ :each | each = aCollection ifTrue: [ ^true ]].
	^false! !

!CompositeCollection methodsFor: 'overriding' stamp: 'emm 05/09/1999 23:14'!
last

	^self at: self size! !

!CompositeCollection methodsFor: 'overriding' stamp: 'emm 05/09/1999 23:14'!
size

	^self inject: 0 into:[ :sum :each | sum + each size ]! !

!SequenceableCollection methodsFor: '*Philemon-Commons' stamp: 'emm 05/09/1999 23:23'!
pairIterator

	^PairwiseCollectionIterator on: self ! !

!SequenceableCollection methodsFor: '*Philemon-Commons' stamp: 'emm 05/09/1999 23:23'!
pairsDo: twoArgBlock

	"Evaluate @twoArgBlock with each consecutive pair of elements from the receiver.
	Example:
		(1 2 3 4) pairs -> (1 2) (3 4)"
	
	self pairIterator do: twoArgBlock! !

Object subclass: #AdditionToEvaluationAdaptor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!AdditionToEvaluationAdaptor class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:16'!
on: aBlock 

	^self new block: aBlock! !

!AdditionToEvaluationAdaptor methodsFor: 'collection-protocol' stamp: 'emm 05/09/1999 23:16'!
add: anObject 

	^block value: anObject! !

!AdditionToEvaluationAdaptor methodsFor: 'collection-protocol' stamp: 'emm 05/09/1999 23:16'!
addAll: aCollection 

	aCollection do: block! !

!AdditionToEvaluationAdaptor methodsFor: 'collection-protocol' stamp: 'emm 05/09/1999 23:16'!
addFirst: anObject 

	^block value: anObject! !

!AdditionToEvaluationAdaptor methodsFor: 'collection-protocol' stamp: 'emm 05/09/1999 23:16'!
addLast: anObject 

	^block value: anObject! !

!AdditionToEvaluationAdaptor methodsFor: 'collection-protocol' stamp: 'emm 05/09/1999 23:16'!
addX: x y: y z: z 

	^block
		value: x@y@z! !

!AdditionToEvaluationAdaptor methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:16'!
block

	^block! !

!AdditionToEvaluationAdaptor methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:16'!
block: aValue

	block := aValue! !

Object subclass: #BitStream
	instanceVariableNames: 'byteStream bitsLeft byte'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

BitStream subclass: #BitReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!BitReadStream class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:16'!
ex0
	"BitReadStream ex0"

	^self on: ( ReadStream on: #[ 2r01010101 2r01010101 ] ).! !

!BitReadStream class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:16'!
ex1
	"BitReadStream ex1"

	^(self on: ( ReadStream on: #[ 1 1 1 1 ] )) nextLong.! !

!BitReadStream methodsFor: 'private' stamp: 'emm 05/09/1999 23:16'!
copyBits: howMany startingAt: start 
	
	| toShift |
	toShift := 9 - start - howMany.
	^( byte bitAnd: ( ( 2r11111111 bitShift: ( howMany - 8 ) ) bitShift: toShift ) ) bitShift: toShift negated! !

!BitReadStream methodsFor: 'inspecting' stamp: 'emm 05/09/1999 23:16'!
inspectActions
	
	^#( reset ) , (self class info selectorsIn: 'tests' ) asArray! !

!BitReadStream methodsFor: 'reading' stamp: 'emm 05/09/1999 23:16'!
next
	
	^self nextBits: 1! !

!BitReadStream methodsFor: 'reading' stamp: 'emm 05/09/1999 23:16'!
next: howMany

	^self nextBits: howMany! !

!BitReadStream methodsFor: 'private' stamp: 'emm 05/09/1999 23:16'!
nextBits: howMany 
	
	| int |
	^howMany <= bitsLeft
		ifTrue: 
			[ int := self copyBits: howMany startingAt: 9 - bitsLeft.
			bitsLeft := bitsLeft - howMany.
			int ]
		ifFalse: 
			[ bitsLeft = 0
				ifTrue: 
					[ byte := byteStream next.
					bitsLeft := 8.
					self nextBits: howMany ]
				ifFalse: 
					[  | toRead |
					int := self copyBits: bitsLeft startingAt: 9 - bitsLeft.
					toRead := howMany - bitsLeft.
					byte := byteStream next.
					bitsLeft := 8.
					( int bitShift: toRead ) + ( self nextBits: toRead ) ] ]! !

!BitReadStream methodsFor: 'reading' stamp: 'emm 05/09/1999 23:16'!
nextByte

	"Answer the next byte"

	^bitsLeft = 0
		ifTrue: [ byteStream next ]
		ifFalse: [ self nextBits: 8 ]! !

!BitReadStream methodsFor: 'reading' stamp: 'emm 05/09/1999 23:16'!
nextBytes: howMany

	"Answer a byte array containing the next @howMany bytes"

	| newByteArray |
	bitsLeft = 0
		ifTrue: [ ^byteStream next: howMany ].
	newByteArray := ByteArray new: howMany.
	1 to: howMany do:[ :i |
		newByteArray at: i put: (self nextBits: 8) ].
	^newByteArray! !

!BitReadStream methodsFor: 'reading' stamp: 'emm 05/09/1999 23:16'!
nextLong

	^( self nextByte bitShift: 24 )
		+ ( self nextByte bitShift: 16 )
		+ ( self nextByte  bitShift: 8 )
		+ self nextByte! !

!BitReadStream methodsFor: 'reading' stamp: 'emm 05/09/1999 23:16'!
nextShort

	^(self nextByte bitShift: 8) + self nextByte ! !

!BitReadStream methodsFor: 'tests' stamp: 'emm 05/09/1999 23:16'!
test1

	| r b |
	r := self on: ( ReadStream on: #[ 2r01010101 2r01010101 ] ).
	(b := r next: 1) = 0
		ifFalse: [ self error: 'test1 failed' ]! !

!BitReadStream methodsFor: 'tests' stamp: 'emm 05/09/1999 23:16'!
test2

	| r b |
	r := self on: ( ReadStream on: #[ 2r01010101 2r01010101 ] ).
	(b := r next: 2) = 1
		ifFalse: [ self error: 'test2 failed' ]! !

!BitReadStream methodsFor: 'tests' stamp: 'emm 05/09/1999 23:16'!
test3

	| r b |
	r := self on: ( ReadStream on: #[ 2r01010101 2r01010101 ] ).
	(b := r next: 4) = 5
		ifFalse: [ self error: 'test3 failed' ]! !

!BitReadStream methodsFor: 'tests' stamp: 'emm 05/09/1999 23:16'!
test5
	| r b |
	r := self on: ( ReadStream on: #[ 2r01010101 2r01010101 ] ).
	(b := r next: 10) = 341
		ifFalse: [ self error: 'test5 failed' ]! !

!BitReadStream methodsFor: 'tests' stamp: 'emm 05/09/1999 23:16'!
test6

	| r b |
	r := self on: ( ReadStream on: #[ 2r01010101 2r01010101 ] ).
	(b := r next: 16) = 21845
		ifFalse: [ self error: 'test6 failed' ]! !

!BitStream class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:16'!
on: aStream
	^(self new) initialize ;setStream: aStream! !

!BitStream methodsFor: 'filestream' stamp: 'emm 05/09/1999 23:16'!
close
	byteStream close! !

!BitStream methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:16'!
initialize
	
	bitsLeft := 0.! !

!BitStream methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:16'!
position

	"Answer the position"

	^byteStream position + 8 - bitsLeft! !

!BitStream methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:16'!
position: index

	"Set the position"! !

!BitStream methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:16'!
reset

	byteStream reset! !

!BitStream methodsFor: 'private' stamp: 'emm 05/09/1999 23:16'!
setStream: aStream
	byteStream := aStream! !

BitStream subclass: #BitWriteStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!BitWriteStream methodsFor: 'writing' stamp: 'emm 02/01/2001 14:54'!
contents

	^byteStream contents! !

!BitWriteStream methodsFor: 'writing' stamp: 'emm 02/01/2001 14:50'!
initialize

	super initialize.
	bitsLeft := 8.
	byte := 0.! !

!BitWriteStream methodsFor: 'writing' stamp: 'emm 05/09/1999 23:16'!
nextPut: zeroOrOne

	self nextPut: 1 from: zeroOrOne! !

!BitWriteStream methodsFor: 'writing' stamp: 'emm 02/01/2001 15:49'!
nextPut: howMany from: anInteger 
	
	| nextInt nextHowMany mask |
	bitsLeft < howMany
		ifTrue: 
			[ bitsLeft > 0 
				ifTrue: 
					[ nextInt := anInteger bitShift: bitsLeft negated.
					nextHowMany := howMany - bitsLeft.
					self nextPut: bitsLeft from: anInteger ].
			byte := 0.
			bitsLeft := 8.
			self nextPut: nextHowMany from: nextInt ]
		ifFalse: 
			[ mask := (16rFF bitShift: howMany - 8 ) bitAnd: anInteger.
			mask := mask bitShift: bitsLeft - howMany.
			bitsLeft := bitsLeft - howMany.
			byte := mask bitOr: byte.
			byteStream nextPut: byte ] ! !

!BitWriteStream methodsFor: 'writing' stamp: 'emm 05/09/1999 23:16'!
nextPutByte: aByteInteger 
	
	bitsLeft = 0
		ifTrue: [ byteStream nextPut: aByteInteger ]
		ifFalse: [ self nextPut: 8 from: aByteInteger ]! !

!BitWriteStream methodsFor: 'writing' stamp: 'emm 05/09/1999 23:16'!
nextPutBytes: aByteArray 
	
	bitsLeft = 0
		ifTrue: [ byteStream nextPutAll: aByteArray ]
		ifFalse: [ aByteArray do: [ :each | self nextPut: 8 from: each ] ]! !

Object subclass: #CompositeInterval
	instanceVariableNames: 'intervals'
	classVariableNames: 'SortBlock'
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!CompositeInterval class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example0
	"self example0"

	| ic |
	ic := self new.
	ic merge: (5 to: 10).
	ic merge: (1 to: 6).
	ic merge: (7 to: 12).
	^ic  = #(1 2 3 4 5 6 7 8 9 10 11 12 )! !

!CompositeInterval class methodsFor: 'examples' stamp: 'emm 20/02/2001 11:50'!
example1
	"self example1"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic subtract: ( 7 to: 9 ).
	^ic = #(5 6 10)! !

!CompositeInterval class methodsFor: 'examples' stamp: 'emm 20/02/2001 11:50'!
example2
	"self example2"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic subtract: ( 7 to: 12 ).
	^ic = #(5 6 )! !

!CompositeInterval class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example3
	"self example3"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic merge: ( 15 to: 20 ).
	ic merge: ( 0 to: 30 ).
	^ic = (0 to: 30)! !

!CompositeInterval class methodsFor: 'examples' stamp: 'emm 20/02/2001 11:50'!
example4
	"self example4"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic subtract: ( 0 to: 15 ).
	^ic = #( )! !

!CompositeInterval class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
new
	^super new initialize! !

!CompositeInterval class methodsFor: 'class-initialization' stamp: 'emm 05/09/1999 23:14'!
sortBlock

	SortBlock isNil
		ifTrue: [ SortBlock := [ :int1 :int2 | int1 first < int2 first ] ].
	^SortBlock! !

!CompositeInterval methodsFor: 'comparing' stamp: 'emm 05/09/1999 23:14'!
= otherCollection

	self size = otherCollection size
		ifFalse: [ ^false ].
	1 to: self size do:[ :i |
		( self at: i ) = ( otherCollection at: i )
			ifFalse:[ ^false ] ].
	^true! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
at: index

	| key |
	key := index.
	intervals do:[ :each |
		key <= each size 
			ifTrue: [ ^each at: key ]
			ifFalse: [ key := key - each size ]].
	^self error: 'index out of bounds'
			! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
do: aBlock

	intervals do:[ :each | each do: aBlock ]! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
first

	^self at: 1! !

!CompositeInterval methodsFor: 'comparing' stamp: 'emm 05/09/1999 23:14'!
hash

	^intervals inject: 0 into:[ :sum :each | sum bitOr: each hash ]! !

!CompositeInterval methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:14'!
initialize

	intervals := SortedCollection new sortBlock: self class sortBlock! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
last

	^self at: self size! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
merge: anInterval
	"Invariant: no element twice"

	anInterval isEmpty
		ifTrue:[ ^self ].
 	intervals do:[ :each |
		( anInterval last < each first )
			ifTrue:[ ^intervals add: anInterval ].
		( anInterval includes: each first )
			ifTrue:
				[self merge: (anInterval class from: anInterval first to: each first - 1).
				^self merge: ( anInterval class from: each last + 1 to: anInterval last )].
		( each includes: anInterval first )
			ifTrue:[ ^self merge: (anInterval class from: each last + 1 to: anInterval last ) ] ].
	intervals add: anInterval
		
			! !

!CompositeInterval methodsFor: 'printing' stamp: 'emm 05/09/1999 23:14'!
printOn: aStream

	intervals do:[ :each | each printOn: aStream. aStream cr ]! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
size

	^intervals inject: 0 into:[ :sum :each | sum + each size ]! !

!CompositeInterval methodsFor: 'private' stamp: 'emm 05/09/1999 23:14'!
split: anInterval at: element 
	
	| tail head |
	intervals remove: anInterval.
	tail := anInterval class from: anInterval first to: element.
	tail isEmpty 
		ifFalse: [ intervals add: tail ].
	head := anInterval class from: element + 1 to: anInterval last.
	head isEmpty 
		ifFalse: [ intervals add: head ]! !

!CompositeInterval methodsFor: 'accessing' stamp: 'emm 20/02/2001 11:51'!
subtract: anInterval

	| tail head |
	anInterval isEmpty
		ifTrue: [ ^self ].
	intervals copy do:[ :each |
		( anInterval includes: each first )
			ifTrue:
				[ ( anInterval includes: each last )
					ifTrue:
						[ ^intervals remove: each ]
					ifFalse: 
						[ each from: anInterval last + 1.
						^self ] ].
		( each includes: anInterval first ) 
			ifTrue: 
				[self split: each at: anInterval first - 1.
				^self subtract: anInterval ]]! !

Object subclass: #EvaluationToAdditionAdaptor
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!EvaluationToAdditionAdaptor class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
new

	^super new initialize! !

!EvaluationToAdditionAdaptor class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
on: aCollection 

	^self new collection: aCollection! !

!EvaluationToAdditionAdaptor methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
collection

	^collection! !

!EvaluationToAdditionAdaptor methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
collection: aCollection 

	collection := aCollection! !

!EvaluationToAdditionAdaptor methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:14'!
initialize

	collection := OrderedCollection new! !

!EvaluationToAdditionAdaptor methodsFor: 'collecting' stamp: 'emm 05/09/1999 23:14'!
value: anObject 

	collection add: anObject.
	^collection! !

!EvaluationToAdditionAdaptor methodsFor: 'collecting' stamp: 'emm 05/09/1999 23:14'!
value: anObject value: otherObject 

	collection add: anObject; add: otherObject.
	^collection! !

!EvaluationToAdditionAdaptor methodsFor: 'collecting' stamp: 'emm 05/09/1999 23:14'!
value: anObject value: otherObject value: yetAnotherObject 

	collection
		 add: anObject
		; add: otherObject
		; add: yetAnotherObject.
	^collection! !

Object subclass: #FieldSet
	instanceVariableNames: 'receiver name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!FieldSet class methodsFor: 'as yet unclassified' stamp: 'emm 10/20/2012 09:57'!
on: aReceiver named: aString value: anObject
	^self new receiver: aReceiver ;name: aString ;value: anObject! !

!FieldSet methodsFor: 'as yet unclassified' stamp: 'emm 10/20/2012 09:54'!
kindDo: r
	^r doFieldSet: self! !

!FieldSet methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:53'!
name
	^ name! !

!FieldSet methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:53'!
name: anObject
	name := anObject! !

!FieldSet methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:56'!
receiver
	^ receiver! !

!FieldSet methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:56'!
receiver: anObject
	receiver := anObject! !

!FieldSet methodsFor: 'as yet unclassified' stamp: 'emm 10/20/2012 09:53'!
value
	^value! !

!FieldSet methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:53'!
value: anObject
	value := anObject! !

Object subclass: #FunctionCall
	instanceVariableNames: 'receiver name parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!FunctionCall class methodsFor: 'as yet unclassified' stamp: 'emm 10/20/2012 09:57'!
on: aReceiver named: aString parameters: params
	^self new receiver: aReceiver ;name: aString ;parameters: params! !

!FunctionCall methodsFor: 'accessing' stamp: 'emm 10/20/2012 08:54'!
name
	^ name! !

!FunctionCall methodsFor: 'accessing' stamp: 'emm 10/20/2012 08:54'!
name: anObject
	name := anObject! !

!FunctionCall methodsFor: 'accessing' stamp: 'emm 10/20/2012 08:54'!
parameters
	^ parameters! !

!FunctionCall methodsFor: 'accessing' stamp: 'emm 10/20/2012 08:54'!
parameters: anObject
	parameters := anObject! !

!FunctionCall methodsFor: 'as yet unclassified' stamp: 'emm 10/20/2012 08:56'!
printOn: aStream
	aStream nextPutAll: name ;nextPut: $(.
	parameters do:[:p| p printOn: aStream] separatedBy:[aStream nextPut: $,].
	aStream nextPut: $).
	
	! !

!FunctionCall methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:56'!
receiver
	^ receiver! !

!FunctionCall methodsFor: 'accessing' stamp: 'emm 10/20/2012 09:56'!
receiver: anObject
	receiver := anObject! !

Object subclass: #InductionBlock
	instanceVariableNames: 'axiom step condition depth maxRecursionDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!InductionBlock class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:24'!
axiom: axiomBlock step: evaluationBlock condition: conditionBlock 

	| rcb |
	rcb := self new.
	rcb axiom: axiomBlock.
	rcb step: evaluationBlock.
	rcb condition: conditionBlock.
	^rcb! !

!InductionBlock class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:24'!
axiom: axiomBlock step: evaluationBlock condition: conditionBlock maxRecursion: maxRecursionDepth 

	| rcb |
	rcb := self new.
	rcb axiom: axiomBlock.
	rcb step: evaluationBlock.
	rcb condition: conditionBlock.
	rcb maxRecursionDepth: maxRecursionDepth.
	^rcb! !

!InductionBlock class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:24'!
axiom: axiomBlock step: evaluationBlock maxRecursion: maxRecursionDepth 

	| rcb |
	rcb := self new.
	rcb axiom: axiomBlock.
	rcb step: evaluationBlock.
	rcb maxRecursionDepth: maxRecursionDepth.
	^rcb! !

!InductionBlock class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:24'!
example1
	"self example1"

	| rcb |
	rcb := self
				axiom: ['there!!' echo]
				step: 
					['on my way' echo.
					rcb value]
				maxRecursion: 4.
	rcb value! !

!InductionBlock class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:24'!
example2
	"self example2"

	| rcb |
	rcb := self
				axiom: [:a | 'there!!' echo]
				step: 
					[:a | 
					'on my way' echo.
					rcb value: 0]
				maxRecursion: 4.
	rcb value: 0! !

!InductionBlock class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:24'!
new

	^super new initialize! !

!InductionBlock methodsFor: 'private' stamp: 'emm 05/09/1999 23:24'!
axiom
	"Answer the recursion axiom block"

	^axiom! !

!InductionBlock methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:24'!
axiom: aBlock 

	axiom := aBlock! !

!InductionBlock methodsFor: 'testing' stamp: 'emm 05/09/1999 23:24'!
canBeEvaluatedFor: argumentArray 
	"Answer whether the induction step can be evaluated using <argumentArray>"

	| enabled |
	self maxRecursionDepth isNil
		ifTrue: [enabled := true]
		ifFalse: [enabled := self depth < self maxRecursionDepth].
	^self condition isNil
		ifTrue: [enabled]
		ifFalse: [enabled or: [self condition valueWithArguments: (Array with: argumentArray)]]! !

!InductionBlock methodsFor: 'private' stamp: 'emm 05/09/1999 23:24'!
condition
	"Answer the recursion condition block"

	^condition! !

!InductionBlock methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:24'!
condition: aBlock 
	"Make sure the condition is a one-argument block"

	condition := [ :arguments | aBlock valueWithArguments: arguments ]! !

!InductionBlock methodsFor: 'private' stamp: 'emm 05/09/1999 23:24'!
depth
	"Answer the recursion depth"

	^depth! !

!InductionBlock methodsFor: 'private' stamp: 'emm 05/09/1999 23:24'!
depth: aValue 
	"Set the recursion depth"

	depth := aValue! !

!InductionBlock methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:24'!
initialize
	"Initialize the receiver by resetting the current recursion depth"

	self unwind! !

!InductionBlock methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:24'!
maxRecursionDepth

	^maxRecursionDepth! !

!InductionBlock methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:24'!
maxRecursionDepth: aValue

	maxRecursionDepth := aValue! !

!InductionBlock methodsFor: 'private' stamp: 'emm 05/09/1999 23:24'!
step
	"Answer the block defining the induction step"

	^step! !

!InductionBlock methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:24'!
step: aBlock 
	"Make sure the step is a one-argument block"

	step := [:arguments | aBlock valueWithArguments: arguments]! !

!InductionBlock methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:24'!
unwind
	"Reset the receiver's recursion depth"

	self depth: 0! !

!InductionBlock methodsFor: 'evaluating' stamp: 'emm 05/09/1999 23:24'!
value

	^self valueWithArguments: #()! !

!InductionBlock methodsFor: 'evaluating' stamp: 'emm 05/09/1999 23:24'!
value: arg1 

	^self valueWithArguments: ( Array with: arg1 )! !

!InductionBlock methodsFor: 'evaluating' stamp: 'emm 05/09/1999 23:24'!
value: arg1 value: arg2 

	^self valueWithArguments: ( Array with: arg1 with: arg2 )! !

!InductionBlock methodsFor: 'evaluating' stamp: 'emm 05/09/1999 23:24'!
value: arg1 value: arg2 value: arg3 

	^self valueWithArguments: ( Array
			with: arg1
			with: arg2
			with: arg3 )! !

!InductionBlock methodsFor: 'evaluating' stamp: 'emm 05/09/1999 23:24'!
value: arg1 value: arg2 value: arg3 value: arg4 

	^self valueWithArguments: ( Array
			with: arg1
			with: arg2
			with: arg3
			with: arg4 )! !

!InductionBlock methodsFor: 'evaluating' stamp: 'emm 05/09/1999 23:24'!
valueWithArguments: anArray 

	^(self canBeEvaluatedFor: anArray)
		ifTrue: 
			[self depth: self depth + 1.
			self step valueWithArguments: (Array with: anArray).
			self depth: self depth - 1]
		ifFalse: [self axiom valueWithArguments: anArray]! !

Object subclass: #IntervalSet
	instanceVariableNames: 'intervals'
	classVariableNames: 'SortBlock'
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!IntervalSet class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example0
	"self example0"

	| ic |
	ic := self new.
	ic merge: (5 to: 10).
	ic merge: (1 to: 6).
	ic merge: (7 to: 12).
	^ic  = #(1 2 3 4 5 6 7 8 9 10 11 12 )! !

!IntervalSet class methodsFor: 'examples' stamp: 'emm 20/02/2001 11:50'!
example1
	"self example1"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic subtract: ( 7 to: 9 ).
	^ic = #(5 6 10)! !

!IntervalSet class methodsFor: 'examples' stamp: 'emm 20/02/2001 11:50'!
example2
	"self example2"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic subtract: ( 7 to: 12 ).
	^ic = #(5 6 )! !

!IntervalSet class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example3
	"self example3"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic merge: ( 15 to: 20 ).
	ic merge: ( 0 to: 30 ).
	^ic = (0 to: 30)! !

!IntervalSet class methodsFor: 'examples' stamp: 'emm 20/02/2001 11:50'!
example4
	"self example4"

	| ic |
	ic := self new.
	ic merge: ( 5 to: 10 ).
	ic subtract: ( 0 to: 15 ).
	^ic = #( )! !

!IntervalSet class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
new
	^super new initialize! !

!IntervalSet class methodsFor: 'class-initialization' stamp: 'emm 05/09/1999 23:14'!
sortBlock

	SortBlock isNil
		ifTrue: [ SortBlock := [ :int1 :int2 | int1 first < int2 first ] ].
	^SortBlock! !

!IntervalSet methodsFor: 'comparing' stamp: 'emm 05/09/1999 23:14'!
= otherCollection

	self size = otherCollection size
		ifFalse: [ ^false ].
	1 to: self size do:[ :i |
		( self at: i ) = ( otherCollection at: i )
			ifFalse:[ ^false ] ].
	^true! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
at: index

	| key |
	key := index.
	intervals do:[ :each |
		key <= each size 
			ifTrue: [ ^each at: key ]
			ifFalse: [ key := key - each size ]].
	^self error: 'index out of bounds'
			! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
do: aBlock

	intervals do:[ :each | each do: aBlock ]! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
first

	^self at: 1! !

!IntervalSet methodsFor: 'comparing' stamp: 'emm 05/09/1999 23:14'!
hash

	^intervals inject: 0 into:[ :sum :each | sum bitOr: each hash ]! !

!IntervalSet methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:14'!
initialize

	intervals := SortedCollection new sortBlock: self class sortBlock! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
last

	^self at: self size! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
merge: anInterval
	"Invariant: no element twice"

	anInterval isEmpty
		ifTrue:[ ^self ].
 	intervals do:[ :each |
		( anInterval last < each first )
			ifTrue:[ ^intervals add: anInterval ].
		( anInterval includes: each first )
			ifTrue:
				[self merge: (anInterval class from: anInterval first to: each first - 1).
				^self merge: ( anInterval class from: each last + 1 to: anInterval last )].
		( each includes: anInterval first )
			ifTrue:[ ^self merge: (anInterval class from: each last + 1 to: anInterval last ) ] ].
	intervals add: anInterval
		
			! !

!IntervalSet methodsFor: 'printing' stamp: 'emm 05/09/1999 23:14'!
printOn: aStream

	intervals do:[ :each | each printOn: aStream. aStream cr ]! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
size

	^intervals inject: 0 into:[ :sum :each | sum + each size ]! !

!IntervalSet methodsFor: 'private' stamp: 'emm 05/09/1999 23:14'!
split: anInterval at: element 
	
	| tail head |
	intervals remove: anInterval.
	tail := anInterval class from: anInterval first to: element.
	tail isEmpty 
		ifFalse: [ intervals add: tail ].
	head := anInterval class from: element + 1 to: anInterval last.
	head isEmpty 
		ifFalse: [ intervals add: head ]! !

!IntervalSet methodsFor: 'accessing' stamp: 'emm 20/02/2001 11:50'!
subtract: anInterval

	| tail head |
	anInterval isEmpty
		ifTrue: [ ^self ].
	intervals copy do:[ :each |
		( anInterval includes: each first )
			ifTrue:
				[ ( anInterval includes: each last )
					ifTrue:
						[ ^intervals remove: each ]
					ifFalse: 
						[ each from: anInterval last + 1.
						^self ] ].
		( each includes: anInterval first ) 
			ifTrue: 
				[self split: each at: anInterval first - 1.
				^self subtract: anInterval ]]! !

Object subclass: #MatrixNxM
	instanceVariableNames: 'collection xySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

MatrixNxM subclass: #ExpandableMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!ExpandableMatrix class methodsFor: 'instance-creation' stamp: 'emm 02/09/2002 20:33'!
new
	^self new: 0 by: 0! !

!ExpandableMatrix methodsFor: 'redefined' stamp: 'emm 02/09/2002 20:33'!
atPoint: aPoint put: anObject

	self checkSizeFor: aPoint.
	^ super atPoint: aPoint put: anObject! !

!ExpandableMatrix methodsFor: 'redefined' stamp: 'emm 02/09/2002 20:33'!
atRow: row column: column put: anObject

	self checkSizeFor: column @ row.
	^ super atRow: row column: column put: anObject! !

!ExpandableMatrix methodsFor: 'redefined' stamp: 'emm 02/09/2002 20:33'!
checkSizeFor: aPoint 
	
	aPoint x > self xSize 
		ifTrue:
			[ self 
				add: aPoint x - self xSize 
				columnsAfter: self xSize 
				fillWith: nil ].
	aPoint y > self ySize 
		ifTrue:
			[ self 
				add: aPoint y - self ySize 
				rowsAfter: self ySize 
				fillWith: nil ]! !

!MatrixNxM class methodsFor: 'examples' stamp: 'emm 02/09/2002 20:33'!
example
	"MatrixNxM example"
	"MatrixNxM example upperTriangularForm"
	"MatrixNxM example determinant"
	"MatrixNxM example invert * MatrixNxM example"

	| mat |
	mat := MatrixNxM new: 3 by: 3.
	mat atPoint: 1 @ 1 put: 3.
	mat atPoint: 1 @ 2 put: 5.
	mat atPoint: 1 @ 3 put: 9.
	mat atPoint: 2 @ 1 put: 1.
	mat atPoint: 2 @ 2 put: -4.
	mat atPoint: 2 @ 3 put: 2.
	mat atPoint: 3 @ 1 put: 6.
	mat atPoint: 3 @ 2 put: 1.
	mat atPoint: 3 @ 3 put: -8.
	^mat! !

!MatrixNxM class methodsFor: 'instance creation' stamp: 'emm 02/09/2002 20:33'!
fromColumnCollection: aRowCollection
	"Produce a new MatrixNxM from a collection of columns.  
	The actual MatrixNxM is an OrderedCollection of Orderedcollections.  "! !

!MatrixNxM class methodsFor: 'instance creation' stamp: 'emm 02/09/2002 20:33'!
fromRowCollection: aRowCollection
	"Produce a new MatrixNxM from a collection of rows.  
	The actual MatrixNxM is an OrderedCollection of Orderedcollections.  "! !

!MatrixNxM class methodsFor: 'instance creation' stamp: 'emm 02/09/2002 20:33'!
new: rows by: columns
	"Produce a new MatrixNxM, a collection of rows and columns.  The actual MatrixNxM is an OrderedCollection of Orderedcollections.  "

	| theNewMatrixNxM |
	theNewMatrixNxM := super new.
	theNewMatrixNxM collection: (Array new: rows * columns).
	theNewMatrixNxM xySize: columns @ rows.
	^theNewMatrixNxM! !

!MatrixNxM class methodsFor: 'instance creation' stamp: 'emm 02/09/2002 20:33'!
new: xySize elements: aCollection 

	| theNewMatrixNxM |
	theNewMatrixNxM := super new.
	theNewMatrixNxM collection: aCollection.
	theNewMatrixNxM xySize: xySize.
	^theNewMatrixNxM! !

!MatrixNxM class methodsFor: 'instance creation' stamp: 'emm 02/09/2002 20:33'!
readFromString: aString

	| newMatrixNxM cr aStream wid hgt |
	cr := Character cr.
	aStream := ReadStream on: aString.
	wid := (aStream upTo: cr) asNumber.
	hgt := (aStream upTo: cr) asNumber.
	newMatrixNxM := MatrixNxM new: hgt by: wid.
	1 to: wid do: [:x |
		1 to: hgt do: [:y | 
			newMatrixNxM atPoint: x @ y put: (aStream upTo: cr) asNumber]].
	^newMatrixNxM! !

!MatrixNxM methodsFor: 'arithmetic' stamp: 'emm 02/09/2002 20:33'!
* aValue
	"Multiplies a MatrixNxM by another MatrixNxM or scalar"

	| sum result k |
	(aValue isKindOf: Number)
		ifTrue:
			[ result := MatrixNxM new: self ySize by: self xSize.
			1 to: self xSize do:
				[:i | 1 to: self ySize do:
					[:j | result atPoint: i @ j put: (self atPoint: i @ j) * aValue]].
			^result].
	(aValue isKindOf: MatrixNxM)
		ifTrue:
			[result := MatrixNxM new: self ySize by: aValue xSize.
			k := self xSize.
			1 to: result ySize do:
				[:i | 1 to: result xSize do:
					[:j |  sum := 0.
						1 to: k do:
							[:t | sum := sum + ((self atPoint: t @ i) * (aValue atPoint: j @ t ))].
						result atPoint: j @ i put: sum]].
			^result].
	self error: 'Improper object to multiply with a matrix'! !

!MatrixNxM methodsFor: 'arithmetic' stamp: 'emm 02/09/2002 20:33'!
+ aMatrixNxM
	"Add a MatrixNxM to another MatrixNxM or scalar"

	| result |
	((aMatrixNxM isKindOf: MatrixNxM) and: [self xySize = aMatrixNxM xySize])
		ifTrue:
			[result := MatrixNxM new: self ySize by: self xSize.
				1 to: self xSize do:
					[:i | 1 to: self ySize do:
							[:j | result atPoint: i@j put: ((self atPoint: i@j) + (aMatrixNxM atPoint: i@j))]].
			^result].
	self error: 'Improper object to add to a matrix'! !

!MatrixNxM methodsFor: 'arithmetic' stamp: 'emm 02/09/2002 20:33'!
- aMatrixNxM
	"Subtract a MatrixNxM from another MatrixNxM or scalar"

	| result |
	((aMatrixNxM isKindOf: MatrixNxM) and: [self xySize = aMatrixNxM xySize])
		ifTrue:
			[result := MatrixNxM new: self ySize by: self xSize.
				1 to: self xSize do:
					[:i | 1 to: self ySize do:
							[:j | result atPoint: i@j put: ((self atPoint: i@j) - (aMatrixNxM atPoint: i@j))]].
			^result].
	self error: 'Improper object to add to a matrix'! !

!MatrixNxM methodsFor: 'arithmetic' stamp: 'emm 02/09/2002 20:33'!
/ aValue
	"Divides a MatrixNxM by another MatrixNxM or scalar"

	|  result |
	(aValue isKindOf: Number)
		ifTrue:
			[ result := MatrixNxM new: self ySize by: self xSize.
			1 to: self xSize do:
				[:i | 1 to: self ySize do:
					[:j | result atPoint: i @ j put: (self atPoint: i @ j) / aValue]].
			^result].
	(aValue isKindOf: MatrixNxM)
		ifTrue:
			[result := self * aValue deepCopy invert.
			^result].
	self error: 'Improper object to multiply with a matrix'! !

!MatrixNxM methodsFor: 'arithmetic' stamp: 'emm 02/09/2002 20:33'!
\\ aScalar
	"take the modulo of each element in the matrix against aScalar"

	| result |
	result := MatrixNxM new: self ySize by: self xSize.
	1 to: self xSize do:
		[:i | 1 to: self ySize do:
				[:j | result atPoint: i@j put: ((self atPoint: i@j) \\ aScalar)]].
	^result! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
acronyms
	| string | 
	"set the contents of all elements of the the acronyms of themselves."

	1 to: self xSize do:
		[:i | 1 to: self ySize do:
			[:j | string := self atPoint: i @ j.
				(string isKindOf: String) ifTrue:[self atPoint: i @ j put: string acronym]]].! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
add: anInteger columnsAfter: start fillWith: anObject
	| result |
	(start < 0 or: [start > self xSize])
		ifTrue: [^self error: 'Attempt to access non-existent element in a MatrixNxM']
		ifFalse: 
			[result := self class new: self ySize by: self xSize + anInteger.
			1 to: self ySize do: [:i | 
				1 to: start do: [:j |
					result atPoint: j @ i put: (self atPoint: j @ i)]].
			1 to: self ySize do: [:i |
				start + 1 to: self xSize do: [:j |
					result atPoint: (j + anInteger) @ i put: (self atPoint: j @ i)]].
			1 to: self ySize do: [:i |
				1 to: anInteger do: [:j |result atPoint: (start + j)@i put: anObject]]].
	xySize x: xySize x + anInteger.
	collection := result collection! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
add: anInteger rowsAfter: start fillWith: anObject
	| result |
	(start < 0 or: [start > self ySize])
		ifTrue: [^self error: 'Attempt to access non-existent element in a MatrixNxM']
		ifFalse: 
			[result := self class new: self ySize + anInteger by: self xSize.
			1 to: self xSize do: [:i | 
				1 to: start do: [:j |
					result atPoint: i @ j put: (self atPoint: i @ j)]].
			1 to: self xSize do: [:i |
				start + 1 to: self ySize do: [:j |
					result atPoint: i @ (j + anInteger) put: (self atPoint: i @ j)]].
			1 to: self xSize do: [:i |
				1 to: anInteger do: [:j | result atPoint: i @ (start + j) put: anObject]]].
	xySize y: xySize y + anInteger.
	collection := result collection! !

!MatrixNxM methodsFor: 'row/column operations' stamp: 'emm 02/09/2002 20:33'!
addColumn: aColumnNumber times: aNumber toColumn: anotherColumnNumber
	"do an elementary column operation"
	1 to: self ySize do: [:each |
		self atPoint: anotherColumnNumber @ each
			put: (self atPoint: aColumnNumber @ each) * aNumber + (self atPoint: anotherColumnNumber @ each)]! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
addColumnAfter: anInteger fillWith: anObject
	| result |
	(anInteger < 0 or: [anInteger > self xSize])
		ifTrue: [^self error: 'Attempt to access non-existent element in a MatrixNxM']
		ifFalse: 
			[result := self class new: self ySize by: self xSize + 1.
			1 to: self ySize do: [:i | 
				1 to: anInteger do: [:j |
					result atPoint: j @ i put: (self atPoint: j @ i)]].
			1 to: self ySize do: [:i |
				anInteger + 1 to: self xSize do: [:j |
					result atPoint: (j + 1) @ i put: (self atPoint: j @ i)]].
			1 to: self ySize do: [:i |
				result atPoint: (anInteger + 1)@i put: anObject]].
	xySize x: xySize x + 1.
	collection := result collection! !

!MatrixNxM methodsFor: 'row/column operations' stamp: 'emm 02/09/2002 20:33'!
addRow: aRowNumber times: aNumber toRow: anotherRowNumber
	"do an elementary row operation"
	1 to: self xSize do: [:each |
		self atPoint: each @ anotherRowNumber
			put: (self atPoint: each @ aRowNumber) * aNumber + (self atPoint: each @ anotherRowNumber)]! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
addRowAfter: anInteger fillWith: anObject
	| result |
	(anInteger < 0 or: [anInteger > self ySize])
		ifTrue: [^self error: 'Attempt to access non-existent element in a MatrixNxM']
		ifFalse: 
			[result := self class new: self ySize + 1 by: self xSize.
			1 to: self xSize do: [:i | 
				1 to: anInteger do: [:j |
					result atPoint: i @ j put: (self atPoint: i @ j)]].
			1 to: self xSize do: [:i |
				anInteger + 1 to: self ySize do: [:j |
					result atPoint: i @ (j + 1) put: (self atPoint: i @ j)]].
			1 to: self xSize do: [:i |
				result atPoint: i @ (anInteger + 1) put: anObject]].
	xySize y: xySize y + 1.
	collection := result collection! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
asColumnMajorCollection
	"return a new OrderedCollection of OrderedCollections in column-major order"
	| oc |
	oc := OrderedCollection new.
	1 to: self xSize do:
		[:column | oc add: (self column: column)].
	^ oc! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
asRowMajorCollection
	"return a new OrderedCollection of OrderedCollections in row-major order"
	| oc |
	oc := OrderedCollection new.
	1 to: self ySize do:
		[:row | oc add: (self row: row)].
	^ oc! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
atPoint: aPoint 
	"return the contents of the matrix element at the specified row and column 
	indices "
	^collection at: aPoint x - 1 * self ySize + aPoint y! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
atPoint: aPoint put: anObject
	"enter an object at the specified row and column indices"
	collection at: aPoint x - 1 * self ySize + aPoint y put: anObject.! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
atRow: y column: x
	"return the contents of the matrix element at the specified row and column indices"

	^collection at:  x - 1 * self ySize + y! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
atRow: y column: x put: anObject
	"enter an object at the specified row and column indices"

	collection at: x - 1 * self ySize + y put: anObject! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
cofactorFor: aPoint
	"return the cofactor for the matrix element given in aPoint"
	| result |
	result := MatrixNxM new: self ySize - 1 by: self xSize - 1.
	1 to: aPoint x - 1 do: [:i |
		1 to: aPoint y - 1 do: [:j |
			result atPoint: i@j put: (self atPoint: i@j)]].
	1 to: aPoint x - 1 do: [:i |
		aPoint y + 1 to: self ySize do: [:j |
			result atPoint: i@(j - 1) put: (self atPoint: i@j)]].
	aPoint x + 1 to: self xSize do: [:i |
		1 to: aPoint y - 1 do: [:j |
			result atPoint: (i - 1)@j put: (self atPoint: i@j)]].
	aPoint x + 1 to: self xSize do: [:i |
		aPoint y + 1 to: self ySize do: [:j |
			result atPoint: (i - 1)@(j - 1) put: (self atPoint: i@j)]].
	^result determinant! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
collection
	^collection! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
collection: aCollection
	collection := aCollection! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
column: anInteger
	| theColumn |
	theColumn := OrderedCollection new.
	1 to: self ySize do: [:i |
		theColumn add: (self atPoint: anInteger @ i)].
	^theColumn! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
copyFromPoint: aPoint toPoint: anotherPoint
	"extract a new matrix which runs from the element at aPoint  to the element at anotherPoint"

	| theNewMatrixNxM i j iCounter jCounter iStop jStop |
	theNewMatrixNxM := MatrixNxM new: anotherPoint y - aPoint y + 1 by: anotherPoint x - aPoint x + 1.
	jStop := anotherPoint y.
	iStop := anotherPoint x.
	iCounter := 0.
	i := aPoint x.
	[i <= iStop]
		whileTrue: 
			[iCounter := iCounter + 1.
			jCounter := 0.
			j := aPoint y.
			[j <= jStop]
				whileTrue: 
					[jCounter := jCounter + 1.
					theNewMatrixNxM atPoint: iCounter @ jCounter put: (self atPoint: i @ j) deepCopy.
					j := j + 1].
			i := i + 1].
	^theNewMatrixNxM! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
copyOn: aStream 
	1 to: self ySize do:  
		[:element | 
		1 to: self xSize do: [:each | 
			(self atPoint: each @ element) printOn: aStream.
			aStream nextPut: Character tab].
		aStream cr]! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
copyString
	| outStream |  
	outStream := WriteStream on: (String new: 200).
	self copyOn: outStream.
	^outStream contents! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
determinant

	self xSize = self ySize ifFalse: [self error: 'No determinant is possible in a non-square matrix'].
	^self deepCopy upperTriangularForm trace! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
diagonalElements
	"return a collection containing the daigonal elements of a square matrix"
	| theDiagonal |

	self xSize = self ySize 
		ifFalse:[^self error: 'The Diagonal is undefined for a non-square matrix'].
	theDiagonal := OrderedCollection new.
	1 to: self xSize do:[:i | theDiagonal add: (self atPoint: i@i)].
	^theDiagonal! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
do: aBlock
	"evaluate aBlock for each element in self"

	| i j iStop jStop |
	jStop := self ySize.
	iStop := self xSize.
	i := 1.
	[i <= iStop]
		whileTrue: 
			[j := 1.
			[j <= jStop]
				whileTrue: 
					[aBlock value: (self atPoint: i @ j).
					j := j + 1].
			i := i + 1].
	^self! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
fromPoint: aPoint toPoint: anotherPoint
	"extract a new matrix which runs from the element at aPoint  to the element at anotherPoint"

	| theNewMatrixNxM i j iCounter jCounter iStop jStop |
	theNewMatrixNxM := MatrixNxM new: anotherPoint y - aPoint y + 1 by: anotherPoint x - aPoint x + 1.
	jStop := anotherPoint y.
	iStop := anotherPoint x.
	iCounter := 0.
	i := aPoint x.
	[i <= iStop]
		whileTrue: 
			[iCounter := iCounter + 1.
			jCounter := 0.
			j := aPoint y.
			[j <= jStop]
				whileTrue: 
					[jCounter := jCounter + 1.
					theNewMatrixNxM atPoint: iCounter @ jCounter put: (self atPoint: i @ j).
					j := j + 1].
			i := i + 1].
	^theNewMatrixNxM! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
fromPoint: aPoint toPoint: anotherPoint do: aBlock
	"extract a new matrix which runs from the element at aPoint  to the element at anotherPoint"
	| jStop iStop i j | 

	jStop := anotherPoint y.
	iStop := anotherPoint x.
	i := aPoint x.
	[i <= iStop]
		whileTrue: 
			[j := aPoint y.
			[j <= jStop]
				whileTrue: 
					[aBlock value: (self atPoint: i @ j).
					j := j + 1].
			i := i + 1].
	^self! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
inverse
	^self deepCopy invert! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
invert
	"Invert a matrix in place. Algorithm by P.Z. Ingerman, uses row operations to invert the matrix in place"

	| eps q order |
	"set the tolerance for singular matrices"
	eps := 0.001.

	"check for squareness, set order of matrix"
	self xSize ~= self ySize ifTrue: [^nil].
	order := self xSize.

	1 to: order do: 
		[:i | 
		q := self atPoint: i@i.
		q abs <= eps abs ifTrue: [^nil].
		self atPoint: i @ i put: 1.
		q ~= 1 ifTrue: [1 to: order do: [:k | self atPoint: k @ i put: (self atPoint: k @ i) / q]].
		1 to: order do: [:j | j ~= i
				ifTrue: 
					[q := self atPoint: i @ j.
					self atPoint: i @ j put: 0.
					self addRow: i times: q negated toRow: j]]]! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
lowerTriangularForm
	"find the lower triangular form of the matrix"
	^self deepCopy lowerTriangularize! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
lowerTriangularize
	"convert a matrix to its lower triangular form"
	| multiplier |
	self ySize to: 1 by: -1 do: [:i |
		i-1 to: 1 by: -1 do: [:j |
			(self atPoint: i@j) = 0 
				ifFalse:[multiplier := -1 * ((self atPoint: i@j) / (self atPoint: i@i)).
					self addRow: i times: multiplier toRow: j]]].! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
max
	"return the max of the elements of a matrix"
	| max |
	max := self atPoint: 1@1.
	self do: [:each | each == nil ifFalse: [each > max ifTrue: [max := each]]].
	^max! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
maxColumns
	
	^self xSize! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
maxRows
	
	^self ySize! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
mean
	"find the range of the elements of a matrix"
	| sum |
	sum := 0.
	self do: [:each |
			sum := sum + each].
	^sum / (self xSize * self ySize)! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
median
	"find the median of the elements of a matrix"
	| arrayOfScores spot |
	arrayOfScores := SortedCollection new.
	self do: [:each |
			arrayOfScores add: each].
	arrayOfScores size even 
		ifTrue:[spot := arrayOfScores size // 2.
			^(arrayOfScores at: spot) + (arrayOfScores at: spot + 1) / 2]
		ifFalse:[^(arrayOfScores at: arrayOfScores size // 2 + 1)]! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
min
	"return the min of the elements of a matrix"
	| min |
	min := self atPoint: 1@1.
	self do: [:each | each == nil ifFalse: [each < min ifTrue: [min := each]]].
	^min! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
mode
	"find the mode of the elements of a matrix"

	| dictOfScores mode topKeySize  |
	dictOfScores := Dictionary new.
	self do:
		[:each | 
		dictOfScores at: each put: (dictOfScores at: each ifAbsent: [0]) + 1].
	topKeySize := 0.
	dictOfScores keys do:
		[:eachKey |
		(dictOfScores at: eachKey) > topKeySize
			ifTrue: 
				[mode := OrderedCollection new.
				mode add: eachKey.
				topKeySize := dictOfScores at: eachKey]
			ifFalse:
				[(dictOfScores at: eachKey) = topKeySize
					ifTrue: [mode add: eachKey]]].
	mode size = 1 ifTrue:[^mode at: 1].
	^mode! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
paste: aMatrixNxM atPoint: aPoint
	"paste another matrix into this one, with the origin of the area to be overwritten at aPoint"

	1 to: aMatrixNxM xSize do:[ :x |
		1 to: aMatrixNxM ySize do:[ :y |
			self 
				atRow: ( aPoint y + y - 1) 
				column: (aPoint x + x - 1)
				put: ( aMatrixNxM atRow: y column: x ) ] ]! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
paste: aMatrixNxM atPoint: aPoint clippingSize: anotherPoint
	"paste another matrix into this one, with the origin of the area to be overwritten at aPoint.  Make sure that the paste is clippped withinb the boundary size specified in anotherPoint and the bounds of this MatrixNxM"

	| iCounter jCounter startPointX stopPointX startPointY stopPointY |
	iCounter := 0.
	startPointX := aPoint x.
	startPointY := aPoint y.
	stopPointX := (startPointX + (aMatrixNxM xSize min: anotherPoint x)) min: self xSize.
	stopPointY := (startPointY + (aMatrixNxM ySize min: anotherPoint y)) min: self ySize.
	startPointX to: stopPointX do:[:i | 
		iCounter := iCounter + 1.
		jCounter := 0.
		startPointY to: stopPointY do: [:j |
			jCounter := jCounter + 1.
			 self atPoint: i @ j put: (aMatrixNxM atPoint: iCounter @ jCounter) deepCopy]].! !

!MatrixNxM methodsFor: 'printing' stamp: 'emm 02/09/2002 20:33'!
printOn: aStream 
	| tooMany |
	tooMany := aStream position + 1000.
	aStream nextPutAll: self class name,' (
'.
	1 to: self ySize do: 
		[:element | 
		aStream position > tooMany ifTrue: [aStream nextPutAll: '...etc...)'. ^self].
		1 to: self xSize do: [:each | 
			(self atPoint: each @ element) printOn: aStream.
			aStream nextPut: Character space].
		aStream cr].
	aStream nextPut: $)! !

!MatrixNxM methodsFor: 'arithmetic' stamp: 'emm 02/09/2002 20:33'!
raisedTo: anInteger 
	"Produce an integer power of a square matrix"

	| result |
	self xSize = self ySize ifFalse: [self error: 'matrix must be square to be raisedTo:'].
	(anInteger isKindOf: Integer)
		ifFalse: [self error: 'matrices may only be raised to integer powers'].
	anInteger < 0 ifTrue: [^self deepCopy invert raisedTo: anInteger abs].
	result := self deepCopy.
	1 to: anInteger - 1 do: [:i | result := result * self].
	^result! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
range
	"find the range of the elements of a matrix"
	| min max |
	min := max := self atPoint: 1@1.
	self do: [:each |
			each < min ifTrue:[min := each].
			each > max ifTrue:[max := each]].
	^max - min! !

!MatrixNxM methodsFor: 'initialize-release' stamp: 'emm 02/09/2002 20:33'!
release
 	self xSize to: 1 by: -1 do:
		[:i |
		self ySize to: 1 by: -1 do:
			[:j |
			(self atPoint: i @ j) release.
			 self atPoint: i @ j put: nil]].
	super release.! !

!MatrixNxM methodsFor: 'shrinking' stamp: 'emm 02/09/2002 20:33'!
removeColumns: nums
	| result n |
	result := MatrixNxM new: self ySize by: self xSize - nums size.
	n := 1.
	1 to: self xSize do:
		[:col |
		(nums includes: col) ifFalse:
		     [1 to: self ySize do:
				[:y | result atPoint: n@y put: (self atPoint: col@y)].
			n := n + 1]].
	xySize x: result xSize.
	collection := result collection! !

!MatrixNxM methodsFor: 'shrinking' stamp: 'emm 02/09/2002 20:33'!
removeRows: nums
	| result n |
	result := MatrixNxM new: self ySize - nums size by: self xSize.
	n := 1.
	1 to: self ySize do:
		[:row |
		(nums includes: row) ifFalse:
			[1 to: self xSize do:
				[:x | result atPoint: x@n put: (self atPoint: x@row)].
			n := n + 1]].
	xySize y: result ySize.
	collection := result collection! !

!MatrixNxM methodsFor: 'enumerating' stamp: 'emm 02/09/2002 20:33'!
row: anInteger
	| theRow |
	theRow := OrderedCollection new.
	1 to: self xSize do: [:i |
		theRow add: (self atPoint: i @ anInteger)].
	^theRow! !

!MatrixNxM methodsFor: 'special setting' stamp: 'emm 02/09/2002 20:33'!
setAsScalar: aValue 
	"set the contents of all elements of the matrix on the diagonal to be aValue.  
	This is a matrix representation of a scalar.  The matrix must be square to be 
	set to this."

	self xSize = self ySize
		ifTrue: 
			[self setToZero.
			1 to: self xSize do: [:i | self atPoint: i @ i put: aValue]]
		ifFalse: [self error: 'Scalar MatrixNxM Must be Square']! !

!MatrixNxM methodsFor: 'private' stamp: 'emm 02/09/2002 20:33'!
setSubSize: anInteger setElements: aCollection
	
	xySize := anInteger.
	collection := aCollection! !

!MatrixNxM methodsFor: 'special setting' stamp: 'emm 02/09/2002 20:33'!
setTo: anObject
	1 to: self xSize do: [:x | 1 to: self ySize do: [:y | self atPoint: x@y put: anObject]]! !

!MatrixNxM methodsFor: 'special setting' stamp: 'emm 02/09/2002 20:33'!
setToOnes
	"set the contents of all elements of the matrix to be zero."

	1 to: self xSize do:
		[:i | 1 to: self ySize do:
			[:j | self atPoint: j @ i put: 1]].! !

!MatrixNxM methodsFor: 'special setting' stamp: 'emm 02/09/2002 20:33'!
setToZero
	"set the contents of all elements of the matrix to be zero."

	1 to: self xSize do:
		[:i | 1 to: self ySize do:
			[:j | self atPoint: j @ i put: 0]].! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
standardDeviation
	"find the standardDeviation of the elements of a matrix"
	| sum standardDeviation thisMean |
	sum := 0.
	thisMean := self mean.
	self do: [:each |
			sum := sum + ((each - thisMean) raisedTo: 2)].
	standardDeviation := (sum / ((self ySize * self xSize) - 1)) sqrt.
	^standardDeviation! !

!MatrixNxM methodsFor: 'printing' stamp: 'emm 02/09/2002 20:33'!
storeOn: aStream 
	| newStream |
	newStream := WriteStream on: String new.
	newStream nextPutAll: self xSize printString.
	newStream cr.
	newStream nextPutAll: self ySize printString.
	newStream cr.
	1 to: self xSize do: 
		[:x | 1 to: self ySize do: 
			[:y | 
			newStream nextPutAll: (self atPoint: x @ y) printString.
			newStream cr]].
	aStream nextPutAll: '(MatrixNxM readFromString: ''' , newStream contents , ''')'! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
sum
	| sum | 
	"sum the elements of a matrix"

	sum := 0.
	self do: [:each | each == nil ifFalse: [sum := sum + each]].
	^sum! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
sumColumns
	"sum the elements of a matrix"

	| i j sum iStop jStop |
	sum := MatrixNxM new: 1 by: self xSize.
	sum setToZero.
	jStop := self ySize.
	iStop := self xSize.
	i := 1.
	[i <= iStop]
		whileTrue: 
			[j := 1.
			[j <= jStop]
				whileTrue: 
					[(self atPoint: i @ j) == nil ifFalse: [sum atPoint: i @ 1 put: (sum atPoint: i @ 1) + (self atPoint: i @ j)].
					j := j + 1].
			i := i + 1].
	^sum! !

!MatrixNxM methodsFor: 'spreadsheet support' stamp: 'emm 02/09/2002 20:33'!
sumRows
	"sum the elements of a matrix"

	| i j sum iStop jStop |
	sum := MatrixNxM new: self ySize by: 1.
	sum setToZero.
	jStop := self ySize.
	iStop := self xSize.
	i := 1.
	[i <= iStop]
		whileTrue: 
			[j := 1.
			[j <= jStop]
				whileTrue: 
					[(self atPoint: i @ j) == nil ifFalse: [sum atPoint: 1 @ j put: (sum atPoint: 1 @ j) + (self atPoint: i @ j)].
					j := j + 1].
			i := i + 1].
	^sum! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
trace
	"compute the trace (product of elements on the main diagonal) of the receiver"
	| product |
	self xSize = self ySize ifFalse: [self error: 'No trace is possible in a non-square matrix'].
	product := 1.
	1 to: self xSize do: [:i |
		product := product * (self atPoint: i@i)].
	^product! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
upperTriangularForm
	"find the upper triangular form of the matrix"
	^self deepCopy upperTriangularize! !

!MatrixNxM methodsFor: 'operations' stamp: 'emm 02/09/2002 20:33'!
upperTriangularize
	"convert a matrix to its upper triangular form"
	| multiplier |
	1 to: self ySize do: [:i |
		i+1 to: self ySize do: [:j |
			(self atPoint: i@j) = 0 
				ifFalse:[multiplier := -1 * ((self atPoint: i@j) / (self atPoint: i@i)).
					self addRow: i times: multiplier toRow: j]]].! !

!MatrixNxM methodsFor: 'statistical accessing' stamp: 'emm 02/09/2002 20:33'!
variance
	"find the variance of the elements of a matrix"

	^self standardDeviation raisedTo: 2! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
xSize
	^xySize x! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
xySize
	^xySize! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
xySize: aPoint
	xySize := aPoint! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
xysize
	"return the x and y density of this matrix"
	self size = 0 ifTrue:[^0@0].
	^self size @ ((self at: 1) size)! !

!MatrixNxM methodsFor: 'accessing' stamp: 'emm 02/09/2002 20:33'!
ySize
	^xySize y! !

Object subclass: #OSFilename
	instanceVariableNames: 'directory regular'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!OSFilename class methodsFor: 'accessing' stamp: 'emm 10/6/2012 21:50'!
fromString: aString
	| slash |
	slash := (aString lastIndexOf: $/) max: (aString lastIndexOf: $\).	
	slash == 0 ifTrue:[^self new directory: '.' regular: aString] ifFalse:[
	^self new directory: (aString copyFrom: 1 to: slash - 1) regular: (aString copyFrom: slash + 1 to: aString size)]! !

!OSFilename class methodsFor: 'accessing' stamp: 'emm 9/22/2012 22:11'!
separatorString
	"Assume *nix for now"
	^'/'! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 9/23/2012 23:32'!
directory 
	^directory ! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 9/22/2012 22:14'!
directory: dirName regular: regName
	directory := dirName.
	regular := regName.! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 9/29/2012 17:38'!
filesMatching: criteria 
	^((FileDirectory on: self regular) matchingEntries: criteria) collect: #fullName! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 10/18/2012 19:14'!
fullName
	^self directory , self class separatorString , self regular! !

!OSFilename methodsFor: 'printing' stamp: 'emm 10/2/2012 21:59'!
printOn: aStream
	aStream
		nextPutAll: '(OSFilename directory:';
		print: directory;
		nextPutAll: ' regular:';
		print: regular;
		nextPut: $)! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 10/18/2012 19:12'!
readStream
	^StandardFileStream readOnlyFileNamed: self fullName 
	
	! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 9/23/2012 23:32'!
regular 
	^regular ! !

!OSFilename methodsFor: 'accessing' stamp: 'emm 10/18/2012 19:32'!
writeStream
	"TODO"
	^StandardFileStream newFileNamed: self fullName
	
	! !

Object subclass: #PairwiseCollectionIterator
	instanceVariableNames: 'collection isCycle fromStep toStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!PairwiseCollectionIterator class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example0
	"self example0"

	^( self on: (1 to: 4) ) pairs! !

!PairwiseCollectionIterator class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example1
	"self example1"

	^( self on: (1 to: 10) ) 
		toStep: 2
		; pairs! !

!PairwiseCollectionIterator class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example2
	"self example2"

	^( self on: (1 to: 9) ) 
		toStep: 2
		; pairs! !

!PairwiseCollectionIterator class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example3
	"self example3"

	^( self on: (1 to: 11) ) 
		toStep: 2
		; pairs! !

!PairwiseCollectionIterator class methodsFor: 'examples' stamp: 'emm 05/09/1999 23:14'!
example4
	"self example4"

	^( self on: (1 to: 18) ) 
		toStep: 3
		; fromStep: 1
		; pairs! !

!PairwiseCollectionIterator class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!PairwiseCollectionIterator class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
on: aCollection
	^self new collection: aCollection! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
collection

	"Answer the value of collection"

	^collection! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
collection: aValue

	"Set the value of collection"

	collection := aValue! !

!PairwiseCollectionIterator methodsFor: 'private' stamp: 'emm 05/09/1999 23:14'!
cyclicDo: twoArgBlock

	| tailIndex headIndex size |
	tailIndex := 1.
	size := self collection size.
	headIndex := tailIndex + toStep - 1 \\ size + 1.
	[ twoArgBlock value: ( self collection at: tailIndex ) value: ( self collection at: headIndex ).
	tailIndex := headIndex + self fromStep - 1 \\ size + 1.
	tailIndex = 1]
		whileFalse:
			[ headIndex := tailIndex + toStep - 1 \\ size + 1]! !

!PairwiseCollectionIterator methodsFor: 'enumerating' stamp: 'emm 08/08/2002 19:25'!
do: twoArgBlock 
	
	"Evaluate @twoArgBlock with each consecutive pair of elements from the 
	receiver's collection"
	
	(self collection notEmpty and:[ self collection size < ( 1 + self toStep ) ])
		ifTrue: [ ^ self error: 'too few elements for pair iteration' ].
	self isCycle
		ifTrue: [ self cyclicDo: twoArgBlock ]
		ifFalse: [ self nonCyclicDo: twoArgBlock ]! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
fromStep

	"Answer the value of fromStep"

	^fromStep! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
fromStep: aValue

	"Set the value of fromStep"

	fromStep := aValue! !

!PairwiseCollectionIterator methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:14'!
initialize

	self isCycle: false.
	self fromStep: 1. "means no overlap"
	self toStep: 1. "means no element skips"! !

!PairwiseCollectionIterator methodsFor: 'inspecting' stamp: 'emm 22/05/2000 15:50'!
inspectActions

	^#( pairs )! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
isCycle

	"Answer the value of isCycle"

	^isCycle! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
isCycle: aValue

	"Set the value of isCycle"

	isCycle := aValue! !

!PairwiseCollectionIterator methodsFor: 'private' stamp: 'emm 05/09/1999 23:14'!
nonCyclicDo: twoArgBlock

	| tailIndex headIndex |
	tailIndex := 1.
	[ headIndex := tailIndex + toStep.
	headIndex <= self collection size ]
		whileTrue:
			[ twoArgBlock value: ( self collection at: tailIndex ) value: ( self collection at: headIndex ).
			tailIndex := headIndex + self fromStep].	! !

!PairwiseCollectionIterator methodsFor: 'computing' stamp: 'emm 05/09/1999 23:14'!
pairs

	| pairs |
	pairs := OrderedCollection new.
	self do:[ :one :two |
		pairs add: (Array with: one with: two)].
	^pairs! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
toStep

	"Answer the value of toStep"

	^toStep! !

!PairwiseCollectionIterator methodsFor: 'accessing' stamp: 'emm 05/09/1999 23:14'!
toStep: aValue

	"Set the value of toStep"

	toStep := aValue! !

Object subclass: #ParallelCollectionsEnumerator
	instanceVariableNames: 'collections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!ParallelCollectionsEnumerator class methodsFor: 'examples' stamp: 'emm 01/08/2002 23:58'!
example0
	"self example0"

	| p |
	p := self new.
	p add: (1 to: 10).
	p add: (5 to: 50 by: 5).
	p add: (0 to: -9 by: -1).
	p ! !

!ParallelCollectionsEnumerator class methodsFor: 'examples' stamp: 'emm 01/08/2002 23:58'!
example1
	"self example1"

	| p |
	p := self new.
	p addFrom: #(0 1) to: #(10 11) in: 5.
	p addTo: #( 15 11 ) in: 5.
	p ! !

!ParallelCollectionsEnumerator class methodsFor: 'instance-creation' stamp: 'emm 05/09/1999 23:14'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!ParallelCollectionsEnumerator methodsFor: 'adding' stamp: 'emm 05/09/1999 23:14'!
add: aCollection

	collections add: aCollection! !

!ParallelCollectionsEnumerator methodsFor: 'adding' stamp: 'emm 05/09/1999 23:14'!
addFrom: startCollection to: stopCollection in: howMany

	"Add intervals to the receiver such that the first tuple equals @startCollection
	and the last tuple equals @stopCollection. The increments are such that each
	interval has a size equal to @howMany"

	startCollection size ~= stopCollection size
		ifTrue: [ ^self error: 'incompatible number of elements in collections' ].
	
	startCollection with: stopCollection do:[ :each :other |
		| by |
		by := ( other - each ) / howMany.
		by = 0
			ifTrue: [ self add: ( CompositeCollection with: (OrderedCollection new: howMany withAll: each) )]
			ifFalse: [ self add: ( CompositeCollection with: ( each to: other by: by ) ) ] ]! !

!ParallelCollectionsEnumerator methodsFor: 'adding' stamp: 'emm 05/09/1999 23:14'!
addTo: stopCollection in: howMany

	| step newSize |
	collections isEmpty
		ifTrue: [ ^self error: 'cannot append to empty collections' ].
	stopCollection size ~= collections first size
		ifFalse: [ ^self error: 'incompatible number of elements in stopCollection' ].
	
	collections with: stopCollection do:[ :eachCollection :other |
		| each |
		each:= eachCollection last.
		step := ( other - each ) / howMany.
		step = 0
			ifFalse: [ eachCollection add: ( each + step to: other by: step ) ] ].

	"Append to constant-value collections with duplicates of the last element"
	newSize := collections inject: 0 into:[ :max :each | max max: each size ].
	collections with: stopCollection do:[ :eachCollection :other |
		| currentSize |
		( currentSize := eachCollection size ) < newSize
			ifTrue:
				[ eachCollection add: ( OrderedCollection new: newSize - currentSize withAll: eachCollection last ) ] ]! !

!ParallelCollectionsEnumerator methodsFor: 'adding' stamp: 'emm 05/09/1999 23:14'!
do: oneArgBlock

	"Evaluate @oneArgBlock for each tuple of elements collected from each collection in the receiver"

	collections isEmpty
		ifTrue: [ ^self ].

	1 to: collections first size do:[ :index |
		oneArgBlock value: ( collections collect:[ :each | each at: index ] ) ]! !

!ParallelCollectionsEnumerator methodsFor: 'initialize-release' stamp: 'emm 05/09/1999 23:14'!
initialize

	collections := OrderedCollection new! !

Object subclass: #RepeatingReadStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!RepeatingReadStream class methodsFor: 'instance-creation' stamp: 'emm 30/07/2001 10:29'!
on: aCollection

	^self new stream: (ReadStream on: aCollection)! !

!RepeatingReadStream methodsFor: 'inspecting' stamp: 'emm 30/07/2001 10:29'!
inspectActions

	^#(next)! !

!RepeatingReadStream methodsFor: 'reading' stamp: 'emm 30/07/2001 10:29'!
next

	stream atEnd ifTrue: [ stream reset ].
	^stream next! !

!RepeatingReadStream methodsFor: 'accessing' stamp: 'emm 30/07/2001 10:29'!
stream

	"Answer the value of stream"

	^stream! !

!RepeatingReadStream methodsFor: 'accessing' stamp: 'emm 30/07/2001 10:29'!
stream: aValue

	"Set the value of stream"

	stream := aValue! !

Object subclass: #TransformedRandom
	instanceVariableNames: 'block random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!TransformedRandom class methodsFor: 'instance-creation' stamp: 'emm 04/09/2012 21:45'!
new
	^super new initialize! !

!TransformedRandom methodsFor: 'accessing' stamp: 'emm 04/09/2012 21:45'!
block

	"Answer the value of block"

	^block! !

!TransformedRandom methodsFor: 'accessing' stamp: 'emm 04/09/2012 21:45'!
block: aValue

	"Set the value of block"

	block := aValue! !

!TransformedRandom methodsFor: 'initialize-release' stamp: 'emm 04/09/2012 21:45'!
initialize
	random := Random new.
	block := [ :seed | seed ]! !

!TransformedRandom methodsFor: 'inspecting' stamp: 'emm 04/09/2012 21:45'!
inspectActions

	^#(next)! !

!TransformedRandom methodsFor: 'initialize-release' stamp: 'emm 04/09/2012 21:45'!
next

	^block value: random next! !

!TransformedRandom methodsFor: 'accessing' stamp: 'emm 04/09/2012 21:45'!
random

	"Answer the value of random"

	^random! !

!TransformedRandom methodsFor: 'accessing' stamp: 'emm 04/09/2012 21:45'!
random: aValue

	"Set the value of random"

	random := aValue! !

Object subclass: #Variable
	instanceVariableNames: 'name type value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Philemon-Commons'!

!Variable class methodsFor: 'instance-creation' stamp: 'emm 01/08/2002 21:55'!
named: aName
	^self basicNew setName: aName! !

!Variable methodsFor: 'enumerating' stamp: 'emm 01/08/2002 21:55'!
allElementsDo: oneArgBlock
	
	"The receiver may represent a node"

	oneArgBlock value: self! !

!Variable methodsFor: 'dispatching' stamp: 'emm 01/08/2002 21:55'!
doesNotUnderstand: aMessage

	^self value perform: aMessage selector withArguments: aMessage arguments! !

!Variable methodsFor: 'enumerating' stamp: 'emm 01/08/2002 21:55'!
keysAndValuesDo: ignore

	"The receiver may represent an element but does not have any properties"! !

!Variable methodsFor: 'dispatching' stamp: 'emm 01/08/2002 21:55'!
kindDo: aRequestor

	^aRequestor doVariable: self! !

!Variable methodsFor: 'accessing' stamp: 'emm 01/08/2002 21:55'!
name

	"Answer the value of name"

	^name! !

!Variable methodsFor: 'accessing' stamp: 'emm 01/08/2002 21:55'!
name: aValue

	"Set the value of name"

	name := aValue! !

!Variable methodsFor: 'printing' stamp: 'emm 01/08/2002 21:55'!
printOn: aStream 
	
	self name isNil 
		ifTrue: [ ^self ]. 
	aStream nextPutAll: self name.! !

!Variable methodsFor: 'expressions' stamp: 'emm 01/08/2002 21:55'!
radiansToDegrees

	^( Expression new )
		receiver: self 
		; message: ( Message new selector: #radiansToDegrees )! !

!Variable methodsFor: 'private' stamp: 'emm 01/08/2002 21:55'!
setName: aName

	self name: aName.
	value := nil! !

!Variable methodsFor: 'accessing' stamp: 'emm 01/08/2002 21:55'!
type

	"Answer the value of type"

	^type! !

!Variable methodsFor: 'accessing' stamp: 'emm 01/08/2002 21:55'!
type: aValue

	"Set the value of type"

	type := aValue! !

!Variable methodsFor: 'accessing' stamp: 'emm 01/08/2002 21:55'!
value

	"Answer the value of value"

	^value! !

!Variable methodsFor: 'accessing' stamp: 'emm 01/08/2002 21:55'!
value: aValue

	"Set the value of value"

	value := aValue! !

!String methodsFor: '*philemon-commons' stamp: 'emm 9/22/2012 22:12'!
asFilename
	^OSFilename fromString: self! !

!String methodsFor: '*philemon-commons' stamp: 'emm 9/28/2012 00:03'!
bindWith: arg1
    ^ self bindWithArguments: (Array with: arg1)! !

!String methodsFor: '*philemon-commons' stamp: 'emm 9/28/2012 00:04'!
bindWith: arg1 with: arg2

    ^ self bindWithArguments: (Array with: arg1 with: arg2)! !

!String methodsFor: '*philemon-commons' stamp: 'emm 9/28/2012 00:03'!
bindWithArguments: aCollection

    | newString end |
    newString := self copy.
    end := aCollection size.
    end to: 1
        by: -1
        do: [:i | newString := newString copyReplaceAll: '%' , i printString with: (aCollection at: i)].
    ^newString ! !
